#include "main.h"

info
*info_create (int max_var_tab, tab *the_tab) {

  info *i;
  int max_lit_tab;

  max_lit_tab = the_tab->num_max_total_lit;

  if (DB(dbtrans))
    printf ("procedure - info_create mvt %d mlt %d\n",
	    max_var_tab, max_lit_tab);
  i = (info *) memory (sizeof(info),"create info struct");
  i->max_var_tab = max_var_tab;
  i->max_lit_tab = max_lit_tab;
  i->num_var_tab = 0;
  i->num_lit_tab = 0;
  i->var_tab = (vtab (*)[]) memory (sizeof(vtab)*max_var_tab,"vtab");
  i->lit_tab = (ltab (*)[]) memory (sizeof(ltab)*max_lit_tab,"ltab");
  i->cur_lit = -1;
  i->cur_level = 0;
  i->the_tab = the_tab;
  return(i);
};



void
info_init (info *i, float bits) {

  int lp, tpos;
  int p[MAX_VAR];
  int j;
  int num_terms;
  
 
  num_terms = ps_epos->preds[0].arity;
  tab_add_examples(i->the_tab,p,&lp);
  tpos = i->num_lit_tab;
  i->num_lit_tab++;
  (*i->lit_tab)[tpos].lit_num = -1;
  (*i->lit_tab)[tpos].level = 0;
  (*i->lit_tab)[tpos].in_vars = -1;
  (*i->lit_tab)[tpos].out_vars = lst_new(num_terms);
  (*i->lit_tab)[tpos].lit_pos = lp;
  (*i->lit_tab)[tpos].lits_used = lst_new(1);
  lst_append((*i->lit_tab)[tpos].lits_used,tpos);
  (*i->lit_tab)[tpos].bits = bits;
  for (j=0;j<num_terms;j++) {
    (*i->var_tab)[j].pos_in_tab = p[j];
    (*i->var_tab)[j].type = lst_look(ps_epos->preds[0].type,j);
    (*i->var_tab)[j].level = 0;
    (*i->var_tab)[j].from_lit = tpos;
    (*i->var_tab)[j].out_var = j;
    lst_insert((*i->lit_tab)[lp].out_vars,j,j);
  }
  i->new_var = TRUE;
  i->num_var_tab = num_terms;
  i->inb = lst_new(0);
  i->outb = lst_new(num_terms);
  for (j=0;j<num_terms;j++) lst_append(i->outb,j);
}


void
info_add_genlit (info *i, int glit_size, int glit_num, glit (*gen_lit)[])
{
	i->max_gen_lit = glit_size;
	i->num_gen_lit = glit_num;
	i->gen_lit = gen_lit;
}

int
prev_lit_better(info *i,int l_pos) 
/* a previous lit is better if it covers more or equal positive example */
/* ane it covers less or equale negative examples */
{
  int h;

  h = tab_bits_hash_fun(i->the_tab,l_pos);
  return ((-1) != (tab_bits_hash_find(i->the_tab,l_pos,h)));

}


/* returns -1 if not same otherwise return the var in tab index */
int
prev_var_same(info *i, int var)
{                                  /* determins wheather a previous variable does the same */

  return -1;
}


int
info_step (info *i) { /* returns true if complete */
  int lit_num;
  int raw_pred;
  pred *p;
  int k,  w, q ;
  int lev, no, ni, l_pos;
  int in_v[MAX_VAR], out_v[MAX_VAR];
  int okay, lev_ok;
  float poscover, negcover, thetacover;
  tab *t;
  lst temp_lst;
  int lit_worth_introducing, some_vars_worth_having, vwh;
  lst vars_worth_having;
  int tpos, vpos;
  int h;

  /* find place to put next literal */

  do {
    lev = 0;
    if (i->cur_lit == -1) {
      for (k=0;k<(*i->gen_lit)[0].num_in;k++) i->cur_pos[k] = -1;
      i->cur_lit = 0;
      i->num_var_tab_lev = i->num_var_tab;
      i->cur_level++;
      lev = (*i->gen_lit)[0].num_in - 1;
      i->new_var = FALSE;
    }
    while (lev >= 0) {
      if ((*i->gen_lit)[i->cur_lit].num_in != 0) {
      do {
	i->cur_pos[lev]++;
	if (lst_look(((*i->gen_lit)[i->cur_lit].type_in),lev)
	    == (*i->var_tab)[i->cur_pos[lev]].type) { /* type okay */
	  k = lev + 1;
	  okay = TRUE;
	  while ((k < (*i->gen_lit)[i->cur_lit].num_in) && okay) {
	    if (i->cur_pos[k] <= i->cur_pos[lev]) okay = FALSE;
	    k++;
	  }
	} else {
	  okay = FALSE;
	}
	
      } while ((!okay) && (i->cur_pos[lev] < i->num_var_tab_lev));
      }
      if ((*i->gen_lit)[i->cur_lit].num_in == 0 || i->cur_pos[lev] >= i->num_var_tab_lev) {
	i->cur_pos[lev] = -1;
	lev++;
	if ((*i->gen_lit)[i->cur_lit].num_in == 0 || lev == (*i->gen_lit)[i->cur_lit].num_in) {
	  do { /* move onto the next literal, if vars used dont use var generating literals */
	    i->cur_lit++;
	    if (i->cur_lit >= i->num_gen_lit) {
	      i->cur_lit = 0;
	      i->cur_level++;
	      i->num_var_tab_lev = i->num_var_tab;
	      if (!i->new_var) return (TRUE); /* Exit if been around once and */
                                              /* new vars introduced. */
	      i->new_var = FALSE;
	    }
	    if (DB(dbtabin)) {
        lit_num = i->cur_lit;
	if (lit_num >= 0) {
		raw_pred = (*i->gen_lit)[lit_num].raw_pred;
		
		if (raw_pred == -1) {
		  p = &(ps_epos->preds[0]);
		} else if (raw_pred < 0)
			p = &(ps_invent->preds[-raw_pred - 2]);
		else
			p = &(ps_bg->preds[raw_pred]);
	} else {
		p = &(ps_epos->preds[0]);
	}

	printf("\n Next literal %s",(*symtable)[lst_look(symtmap,p->name)].lexptr);


	      printf(" in %d out %d level %d num lits %d tab level %d vars used %d hash hit %2.2e %2.2e\n",
		     (*i->gen_lit)[i->cur_lit].num_in,
		     (*i->gen_lit)[i->cur_lit].num_out,  
		     i->cur_level, 
		     i->num_lit_tab,
		     i->num_var_tab_lev,
		     i->num_var_tab,
                     bhts/bhtc,
		     vhts/vhtc);
	    }
	  } while ((((*i->gen_lit)[i->cur_lit].num_out > 0) && 
		   (i->num_var_tab >=  (i->max_var_tab -1) )) || 
                   ((((*i->gen_lit)[i->cur_lit].num_in == 0)) &&
                   (i->cur_level > 1)));
	  for (k=0;k<(*i->gen_lit)[i->cur_lit].num_in;k++)
	    i->cur_pos[k] = -1;
	  lev = (*i->gen_lit)[i->cur_lit].num_in - 1;
	}
      } else {
	lev--;
      }
    }

    if ((*i->gen_lit)[i->cur_lit].num_in == 0) {
      lev_ok = TRUE;
    } else {
      lev_ok = FALSE; /* one varible must be from the previous level */
      k = 0;
      while ((k < (*i->gen_lit)[i->cur_lit].num_in) && !lev_ok) {
	if ((*i->var_tab)[i->cur_pos[k]].level == i->cur_level-1)
	  lev_ok = TRUE;
	k++;
      }
    }
  } while (!lev_ok);
  
  
  /* calculate the value of the literal are new variables */


  ni = (*i->gen_lit)[i->cur_lit].num_in;
  no = (*i->gen_lit)[i->cur_lit].num_out;
  if (i->num_var_tab + no > i->max_var_tab) error ("var tab needs extending"); 
  for (k=0;k<ni;k++) {
    in_v[k] = (*i->var_tab)[i->cur_pos[k]].pos_in_tab;
  }

  tab_new_lit(i->the_tab,
	      ni,in_v,
	      no,out_v,
	      (*i->gen_lit)[i->cur_lit].fun,
	      &l_pos,
	      ((*i->gen_lit)[i->cur_lit].raw_pred == -1));


  tab_cover(i->the_tab, l_pos, &poscover, &negcover, &thetacover);

/* is the literal worth having ? is each var worth having ? is the lit at all worth having ? */

  h = tab_bits_hash_fun(i->the_tab,l_pos);
  lit_worth_introducing = tab_bits_hash_find(i->the_tab,l_pos,h); /* -1 it is worth introducing */
  vars_worth_having = lst_new(no);
  some_vars_worth_having = FALSE;
  for (k=0;k<no;k++) {
    vwh = tab_vec_hash_find(i->the_tab,out_v[k]); 
    if (vwh == -1) some_vars_worth_having = TRUE;
    lst_append(vars_worth_having,vwh); 
  }

  if (((poscover > 0.0) || (i->the_tab->num_w_p < 5.0)) && 
      ((lit_worth_introducing == -1) || some_vars_worth_having)) { /* introduce lits and vars */
    if (lit_worth_introducing != -1) {
      tab_free_lit(i->the_tab,l_pos);     
      l_pos = -1;
    } else {
      h = tab_bits_hash_fun(i->the_tab,l_pos);
      tab_bits_hash_add(i->the_tab,l_pos,h);
    }
    tpos = i->num_lit_tab;  /* set up the ltab */
    i->num_lit_tab++;  
    (*i->lit_tab)[tpos].lit_num = i->cur_lit;
    (*i->lit_tab)[tpos].level = i->cur_level;
    (*i->lit_tab)[tpos].in_vars = lst_new(ni);
       for (k=0;k<ni;k++) 
          lst_append((*i->lit_tab)[tpos].in_vars,i->cur_pos[k]);
    (*i->lit_tab)[tpos].out_vars = lst_new(no);
    (*i->lit_tab)[tpos].lit_pos = l_pos;
    (*i->lit_tab)[tpos].lits_used = lst_new(5);
    lst_append((*i->lit_tab)[tpos].lits_used,tpos);
    temp_lst = lst_new(10);
    lst_merge((*i->lit_tab)[tpos].lits_used,
	      (*i->lit_tab)[0].lits_used,
	      temp_lst);
    lst_copy(temp_lst,(*i->lit_tab)[tpos].lits_used);
    for (k=0;k<ni;k++) {
      lst_merge((*i->lit_tab)[tpos].lits_used,
		(*i->lit_tab)[(*i->var_tab)[i->cur_pos[k]].from_lit].lits_used,
		temp_lst);
      lst_copy(temp_lst,(*i->lit_tab)[tpos].lits_used);
    }
    (*i->lit_tab)[tpos].bits = (*i->gen_lit)[i->cur_lit].bits;
    
    for (k=0;k<no;k++) {
      /* the var is worth having */
	vpos = i->num_var_tab;
	i->num_var_tab++;
	lst_append((*i->lit_tab)[tpos].out_vars,vpos);
	(*i->var_tab)[vpos].pos_in_tab = out_v[k];
	(*i->var_tab)[vpos].type = lst_look(((*i->gen_lit)[i->cur_lit].type_out),k);
	(*i->var_tab)[vpos].level = i->cur_level;
	(*i->var_tab)[vpos].from_lit = tpos;
	(*i->var_tab)[vpos].out_var = k;
	i->new_var = TRUE;
	tab_vec_hash_add(i->the_tab,out_v[k]);
	/*} else {                                 
	lst_append((*i->lit_tab)[tpos].out_vars,-1);
	tab_free_var(i->the_tab,out_v[k]);
	if (DB(dbtabex)) {
	  printf ("+ %6.2f - %6.2f t %6.2f ", poscover,negcover,thetacover);
	  printf ("** Var removed Info Step adding %d from ",i->cur_lit);
	  for (kk=0;k<(*i->gen_lit)[i->cur_lit].num_in;kk++)
	    printf("%d ",i->cur_pos[kk]);
	  printf(" to ");
	  for (kk=0;kk<no;kk++)
	    printf("%d ",out_v[kk]);
	  printf("\n");
	} 
      }*/
    }
           
    if (DB(dbtabin)) {
      printf ("+ %6.2f - %6.2f t %6.2f ", poscover,negcover,thetacover);
      printf ("Info Step adding %d from ",i->cur_lit);
      for (k=0;k<(*i->gen_lit)[i->cur_lit].num_in;k++)
	printf("%d ",i->cur_pos[k]);
      printf(" to ");
      for (k=0;k<no;k++)
	printf("%d ",out_v[k]);
      printf("l_pos %d\n",l_pos);
      show_c(stdout,(*i->lit_tab)[tpos].lits_used,i);printf("\n");
    }
    if (DB(dbvtab)) {
      t = i->the_tab;
      printf("x-%d-%d- = %d\n",k,i->num_var_tab,(*i->var_tab)[k].pos_in_tab);
      for (w=0;w<t->num_et;w++) { 
	for (q=0;q<i->num_var_tab;q++)
	  printf("%4d",(*t->var_table)[(*i->var_tab)[q].pos_in_tab * (t->num_et) + w]);
	printf("\n");  
      }
    }
  } else { /* remove lits and vars from tab */
    tab_free_lit(i->the_tab,l_pos);
    for (k=0;k<no;k++) {
      tab_free_var(i->the_tab,out_v[k]);
    }

    if (DB(dbtabex)) {
      printf ("+ %6.2f - %6.2f t %6.2f ", poscover,negcover,thetacover);
      printf ("** REMOVED lit %d from ",i->cur_lit);
      for (k=0;k<(*i->gen_lit)[i->cur_lit].num_in;k++)
	printf("%d ",i->cur_pos[k]);
      printf(" to ");
      for (k=0;k<no;k++)
	printf("%d ",out_v[k]);
      printf("lwh %d",lit_worth_introducing);
      printf(" vwh ");
      lst_show(vars_worth_having);
      printf("\n");
    }

  } 
  lst_free(vars_worth_having);
  return (FALSE);

};


float
info_bits(info *i, lst lits)
{
  int j, lit;
  float s;
  
  s = 0.0;
  for (j=0;j<lst_size(lits);j++) {
    lit = lst_look(lits,j);
    s = s + (*i->lit_tab)[lit].bits;
  }
  return s;
}



