/* table.c */

#include"main.h"
#include<math.h>

tab
*tab_create(int num_e_p, int num_e_n, int num_theta,
			int num_max_total_lit, int num_max_vars)
{
  tab *t;
  int mem_req;


  if (DB(dbtrans)) printf("tab_create np %d nn %d nt %d mtl %d mv %d\n",
			  num_e_p, num_e_n, num_theta,
			  num_max_total_lit, num_max_vars);
  
  t = (tab *) memory (sizeof(tab),"create tab struct");
  t->num_e_p = num_e_p;
  t->num_e_n = num_e_n;
  t->num_theta = num_theta;
  t->num_et = num_e_p + num_e_n + num_theta;
  t->num_max_total_lit = num_max_total_lit;
  t->num_max_vars = num_max_vars;
  mem_req = sizeof(int) * num_max_vars * t->num_et;
  t->lit_cover_p = bvs_create(num_e_p,num_max_total_lit);
  t->lit_cover_n = bvs_create(num_e_n,num_max_total_lit);
  t->lit_cover_t = bvs_create(num_theta,num_max_total_lit); 
  t->cover_p = (float (*)[]) memory(sizeof(float) * num_max_total_lit, "float cover vector"); 
  t->cover_n = (float (*)[]) memory(sizeof(float) * num_max_total_lit, "float cover vector"); 
  t->cover_t = (float (*)[]) memory(sizeof(float) * num_max_total_lit, "float cover vector"); 
  t->var_table = (int (*)[]) memory(mem_req, "creating data for  var table");

  t->weight_p = (float (*)[]) memory(sizeof(float) * num_e_p,"floating point weight vector");
  t->weight_n = (float (*)[]) memory(sizeof(float) * num_e_n,"floating point weight vector");
  t->weight_t = (float (*)[]) memory(sizeof(float) * num_theta,"floating point weight vector");

  t->var_free_list = fl_create(num_max_vars);
  t->lit_free_list = fl_create(num_max_total_lit);
  t->hash_bits = lst_new(num_max_total_lit*6);
  lst_fill(t->hash_bits,num_max_total_lit*6,-1);
  t->hash_vec = lst_new(num_max_vars*6);
  lst_fill(t->hash_vec,num_max_vars*6,-1);
  return(t);
}

int 
tab_bits_hash_fun(tab *t,int pos)
{
  int p,n,th,m;

  m = lst_size(t->hash_bits);
  p = bvs_hash_fun(t->lit_cover_p,pos);
  n = bvs_hash_fun(t->lit_cover_n,pos);
  th = bvs_hash_fun(t->lit_cover_t,pos);
  return ((p + 111*n + 1111*th ) % m);
}


float bhtc = 0.0;
float bhts = 0.0;


int
tab_bits_hash_notfindadd(tab *t, int pos) {
  int h;
  lst l;

  h = tab_bits_hash_fun(t,pos);
  l = tab_bits_hash_find(t,pos,h);
  if (l == -1) {
    tab_bits_hash_add(t,pos,h);
    return h;
  } else {
    return -1;
  }
}

void
tab_bits_hash_add(tab *t, int pos, int h)
{
  lst l;

  bhtc = bhtc + 1.0;
  if (lst_look(t->hash_bits,h) == -1) {
    lst_insert(t->hash_bits,lst_new(3),h);
  }
  l = lst_look(t->hash_bits,h);
  bhts = bhts + lst_size(l);
  lst_append(l,pos);
}

int
tab_bits_hash_find(tab *t, int pos, int h)
{
  lst pl;
  int j,ol;


  pl = lst_look(t->hash_bits,h);

  if (pl == -1) {
    return (-1);
  }

  for (j=0;j<lst_size(pl);j++) {
    ol = lst_look(pl,j);
    /*printf("hash_bits %d, h %d, pl %d, ol %d, j %d ",t->hash_bits,h,pl,ol,j);
lst_show(pl); printf("\n");*/
    if ((bvs_eq(t->lit_cover_p,pos,ol)) && 
        (bvs_eq(t->lit_cover_n,pos,ol)) &&
        (bvs_eq(t->lit_cover_t,pos,ol)))
      return ol;
  }
  return (-1);
}


int 
tab_vec_hash_fun(tab *t,int pos)
{
  int m,k,x;
  unsigned long c;

  m = lst_size(t->hash_vec);
  c = (unsigned long) 0;
  for(k = 0; k < t->num_et; k++) {
    x = (*t->var_table)[pos * t->num_et + k];
    c = (c + look_rlist(k)*x) % (unsigned long) 57123;
  }
  return (c % m);
}


void
tab_hash_bits_clear(tab *t) 
{
  int m, j;
  lst l;

  m = lst_size(t->hash_bits);
  for (j=0;j<m;j++) {
    l = lst_look(t->hash_bits,j);
    if (l != -1) {
      lst_free(l);
      lst_insert(t->hash_bits,-1,j);
    }
  }

}

float vhtc = 0.0;
float vhts = 0.0;

void
tab_vec_hash_add(tab *t, int pos)
{
  int h;
  lst l;

  vhtc = vhtc + 1.0;
  h = tab_vec_hash_fun(t,pos);
  if (lst_look(t->hash_vec,h) == -1) {
    lst_insert(t->hash_vec,lst_new(3),h);
  }
  l = lst_look(t->hash_vec,h);
  vhts = vhts + lst_size(l);
  lst_append(l,pos);
}

int
tab_vec_hash_find(tab *t, int pos)
{
  int h;
  lst pl;
  int j,ol;

  h = tab_vec_hash_fun(t,pos);
  pl = lst_look(t->hash_vec,h);
  if (pl == -1) {
    return (-1);
  }

  for (j=0;j<lst_size(pl);j++) {
    ol = lst_look(pl,j);
    if (arr_cmp(t->num_et,
		*t->var_table,t->num_et*ol,
		*t->var_table,t->num_et*pos))
      return ol;
  }
  return (-1);
}


void
tab_add_examples(tab *t,int term_place[], int *lit_place)
{
  int i,j;
  int pos,posl;
  int vw, num_terms;
  float sumw;

  num_terms = ps_epos->preds[0].arity;
  *lit_place = posl = fl_get(t->lit_free_list);
  vw = t->num_et;
  for (i=0;i<num_terms;i++) {
    term_place[i] = (pos = fl_get(t->var_free_list));
    for(j=0;j<t->num_e_p;j++) {
      (*t->var_table)[pos*vw + j] =
	lst_look(lst_look(ps_epos->preds[0].preds,j),i);
    }
    for(j=0;j<t->num_e_n;j++) {
      (*t->var_table)[pos*vw + t->num_e_p + j] =
	lst_look(lst_look(ps_eneg->preds[0].preds,j),i);
    }
    for(j=0;j<t->num_theta;j++) {
      (*t->var_table)[pos*vw + t->num_e_p + t->num_e_n + j] =
	lst_look(lst_look(ps_theta->preds[0].preds,j),i);
    }
  }
  bvs_clear(t->lit_cover_p,posl,1);
  bvs_clear(t->lit_cover_n,posl,1);
  bvs_clear(t->lit_cover_t,posl,1);

 
  sumw = 0.0;
  for(j=0;j<t->num_e_p;j++) {
    (*t->weight_p)[j] = (float) lst_look(ps_epos->preds[0].number,j);
    sumw += (*t->weight_p)[j];
  }
  t->num_w_p = sumw;


  sumw = 0.0;
  for(j=0;j<t->num_e_n;j++) {
    (*t->weight_n)[j] = (float) lst_look(ps_eneg->preds[0].number,j);
     sumw += (*t->weight_n)[j];
  }
  t->num_w_n = sumw;

  sumw = 0.0;
  for(j=0;j<t->num_theta;j++) {
    (*t->weight_t)[j] = (float) lst_look(ps_theta->preds[0].number,j);
    sumw += (*t->weight_t)[j] ;
  }
  t->num_w_t = sumw;

  (*t->cover_p)[posl] = t->num_w_p;
  (*t->cover_n)[posl] = t->num_w_n;
  (*t->cover_t)[posl] = t->num_w_t;

}

void
tab_new_lit(tab *t, int num_in_vars, int in_vars[],
			int num_out_vars, int out_vars[],
			map *f, int *lit_pos,
			int is_rec)
{
  int pos;
  int i,j;
  int tm1[MAX_VAR];
  int tm2[MAX_VAR];
  int num_e;
  int cont_loop, found;
  lst rec_tab;
  int idx, k;
  float cover;

  rec_tab = -1; /* keep the complier quiet */
  if (is_rec) {
    rec_tab = lst_new(t->num_e_p);
    for (i=0;i<t->num_e_p;i++) lst_append(rec_tab,-1);
  }

  /* allocate places */
  num_e = t->num_et;
  *lit_pos = pos = fl_get(t->lit_free_list);
  if (pos == -1) error ("lits full\n");
  for (i=0;i<num_out_vars;i++) {
		out_vars[i] = fl_get(t->var_free_list);
	      }
  
  /* set cover and table */
  found = FALSE;
  cover = 0.0;
  for (i=0;i<t->num_e_p;i++) {
    cont_loop = TRUE;
    for (j=0;j<num_in_vars && cont_loop;j++) {
      tm1[j] = (*t->var_table)[num_e*in_vars[j] + i];
      if (tm1[j] == -1) cont_loop = FALSE;
    }
    if (cont_loop) {
      
      if (is_rec) {
	found = map_lookup(f,tm1,tm2,&idx);
	if (found) {
	  
	  k = idx;
	  while ( (k != -1) && (!lst_member(i,k))) {
	    k = lst_look(rec_tab,lst_look(k,0));
	  }
	  if (k != -1) {
	    found = FALSE;
	  } else {
	    lst_insert(rec_tab,idx,i);
	  }   
	    
	}
      } else {
	found = map_lookup(f,tm1,tm2,&idx);
      }
    }
    /*printf("cont_loop %d found %d tm1 %d tm2 %d ",cont_loop,found,tm1[0],tm2[0]);*/
    if (cont_loop && found) {
      for (j=0;j<num_out_vars;j++) {
	(*t->var_table)[num_e*out_vars[j]+i] = tm2[j];
	/*printf("^+@ %d %d %d d %d %d \n",out_vars[j], i, num_e*out_vars[j]+i, tm2[j],(*t->var_table)[num_e*out_vars[j]+i]);*/
      }
      bvs_set(t->lit_cover_p,pos,i,1);
      cover += (*t->weight_p)[i]; 
   } else {
      for (j=0;j<num_out_vars;j++) {
	(*t->var_table)[num_e*out_vars[j]+i] = -1;
      }
      bvs_set(t->lit_cover_p,pos,i,0);
    }
  }
  (*t->cover_p)[pos] = cover;

  cover = 0.0;
  for (i=0;i<t->num_e_n;i++) {
    cont_loop = TRUE;
    for (j=0;j<num_in_vars && cont_loop;j++) {
      tm1[j] = (*t->var_table)[num_e*in_vars[j] + t->num_e_p + i];
      if (tm1[j] == -1) cont_loop = FALSE;
      }
    if (cont_loop) {
      found = map_lookup(f,tm1,tm2,&idx);
    }
    if (cont_loop && found) {
      for (j=0;j<num_out_vars;j++) {
	  (*t->var_table)[num_e*out_vars[j]+ t->num_e_p + i] = tm2[j];
	  /*printf("^-@ %d %d %d %d d %d %d \n",j,out_vars[j], i, num_e*out_vars[j]+t->num_e_p+i, tm2[j],(*t->var_table)[num_e*out_vars[j]+t->num_e_p+i]);*/
	}
      bvs_set(t->lit_cover_n,pos,i,1);
      cover += (*t->weight_n)[i];
    } else {
      for (j=0;j<num_out_vars;j++) {
	(*t->var_table)[num_e*out_vars[j]+ t->num_e_p + i] = -1;
      }
      bvs_set(t->lit_cover_n,pos,i,0);
    }
  }
  (*t->cover_n)[pos] = cover;

  cover = 0.0;
  for (i=0;i<t->num_theta;i++) {
    cont_loop = TRUE;
    for (j=0;j<num_in_vars && cont_loop;j++) {
      tm1[j] = (*t->var_table)[num_e*in_vars[j] + t->num_e_p + t->num_e_n+ i];
      if (tm1[j] == -1) cont_loop = FALSE;
      }
    if (cont_loop) {
      found = map_lookup(f,tm1,tm2,&idx);
    }
    if (cont_loop && found) {
      for (j=0;j<num_out_vars;j++) {
	(*t->var_table)[num_e*out_vars[j]+ t->num_e_p + t->num_e_n + i] = tm2[j];
      }
      bvs_set(t->lit_cover_t,pos,i,1);
      cover += (*t->weight_t)[i];
    } else {
      for (j=0;j<num_out_vars;j++) {
	(*t->var_table)[num_e*out_vars[j]+ t->num_e_p +t->num_e_n+ i] = -1;
      }
      bvs_set(t->lit_cover_t,pos,i,0);
    }
  }
  (*t->cover_t)[pos] = cover;
  

  if (is_rec) lst_free(rec_tab);
}

void
tab_free_lit(tab *t, int pos)
{
	fl_free(t->lit_free_list,pos);
}

void
tab_free_var(tab *t, int vpos)
{
	fl_free(t->var_free_list,vpos);
}

void
tab_show(tab *t)
{
int i,j;

	printf("num_e_p %d ",t->num_e_p);
	printf("num_e_n %d\n",t->num_e_n);
	printf("nmtl %d ",t->num_max_total_lit);
	printf("nmv %d\n",t->num_max_vars); 
	printf("+\n"); bvs_show(t->lit_cover_p);
       
	printf("-\n"); bvs_show(t->lit_cover_n);
	
	for (i=0;i<t->num_et;i++) {
		for (j=0;j<9 /*t->num_max_vars*/;j++)
			printf ("%d\t",(*t->var_table)[j*(t->num_et) + i]);
		printf("\n");
	}

}

void
info_tab_show(tab *t, info *i) 
{
  int j, k,  lit, svt;
  lst tlu, index;
  int vpos, val;

  printf("\nThe literals\n");
  for (j=0;j<i->num_lit_tab;j++) {
    tlu = (*i->lit_tab)[j].lits_used;
    printf("%4d ",j);show_c (stdout, tlu, i);
    printf("\n");
  }

  printf("\nPositive Coverage\n");
  index = lst_new(600);
  for (j=0;j<i->num_lit_tab;j++) {
    if (j <= 40) {
    lit = (*i->lit_tab)[j].lit_pos; 
    lst_append(index,lit);
    }
  }
   

  bvs_show_index(index,t->lit_cover_p);
  printf("\nNegative Coverage\n");
  bvs_show_index(index,t->lit_cover_n);
    /* printf("\nTheta Coverage\n");
  bvs_show_index(index,t->lit_cover_t);*/
  lst_free(index);

  printf("\n Positive Variable bindings\n");
    
  for (j=0;j<i->num_var_tab;j++) printf ("  %1d",(j/10)%10); printf("\n");
  for (j=0;j<i->num_var_tab;j++) printf ("  %1d",j%10); printf("\n");
  for (j=0;j<i->num_var_tab;j++) printf ("---"); printf("\n");


  svt = i->num_var_tab<40?i->num_var_tab:40;
  for (k=0;k<t->num_e_p;k++) {
    for (j=0;j<svt;j++) {
      vpos = (*i->var_tab)[j].pos_in_tab;
      val = (*t->var_table)[vpos*(t->num_et) + k];
      if (val == -1) { 
	printf("  X");
      } else {
	printf (" %2d",val);
      } 
    }
    printf("\n");
  }  

  printf("\n Negative Variable bindings\n");
    
  for (j=0;j<i->num_var_tab;j++) printf ("  %1d",(j/10)%10); printf("\n");
  for (j=0;j<i->num_var_tab;j++) printf ("  %1d",j%10); printf("\n");
  for (j=0;j<i->num_var_tab;j++) printf ("---"); printf("\n");

  for (k=0;k<t->num_e_n;k++) {
    for (j=0;j<i->num_var_tab;j++) {
      vpos = (*i->var_tab)[j].pos_in_tab;
      val = (*t->var_table)[vpos*(t->num_et) + t->num_e_p + k];
      if (val == -1) { 
	printf("  X");
      } else {
	printf (" %2d",val);
      } 
    }
    printf("\n");
  }
}



void
cal_cover(tab *t, int lit)
{
  (*t->cover_p)[lit] = bvs_dot_f(t->lit_cover_p,lit,(*t->weight_p));
  (*t->cover_n)[lit] = bvs_dot_f(t->lit_cover_n,lit,(*t->weight_n));
  (*t->cover_t)[lit] = bvs_dot_f(t->lit_cover_t,lit,(*t->weight_t));
}

void
no_cover(tab *t, int lit) {
  bvs_clear(t->lit_cover_p,  lit,0);
  bvs_clear(t->lit_cover_n,  lit,0);
  bvs_clear(t->lit_cover_t,  lit,0);
  (*t->cover_p)[lit] = 0.0;
  (*t->cover_n)[lit] = 0.0;
  (*t->cover_t)[lit] = 0.0;
}

void
tab_cover(tab *t, int lit, float *pc, float *nc, float *tc)
{
	*pc = (*t->cover_p)[lit];
	*nc = (*t->cover_n)[lit];
	*tc = (*t->cover_t)[lit];
}

int
tab_replicate(tab *t, int lit)
{
 int litp;

 litp = fl_get(t->lit_free_list);
 bvs_copy(t->lit_cover_p,  lit,litp);
 bvs_copy(t->lit_cover_n,  lit,litp);
 bvs_copy(t->lit_cover_t,  lit,litp);
 (*t->cover_p)[litp] = (*t->cover_p)[lit];
 (*t->cover_n)[litp] = (*t->cover_n)[lit];
 (*t->cover_t)[litp] = (*t->cover_t)[lit];
 return (litp);
}

void
tab_copy(tab *t, int lit, int litp)
{
  bvs_copy(t->lit_cover_p,  lit,litp);
  bvs_copy(t->lit_cover_n,  lit,litp);
  bvs_copy(t->lit_cover_t,  lit,litp);
  (*t->cover_p)[litp] = (*t->cover_p)[lit];
  (*t->cover_n)[litp] = (*t->cover_n)[lit];
  (*t->cover_t)[litp] = (*t->cover_t)[lit];
}


void
tab_clear(tab *t, int lit)
{
  bvs_clear(t->lit_cover_p,  lit,0);
  bvs_clear(t->lit_cover_n,  lit,0);
  bvs_clear(t->lit_cover_t,  lit,0);
  (*t->cover_p)[lit] = 0.0;
  (*t->cover_n)[lit] = 0.0;
  (*t->cover_t)[lit] = 0.0;
}

