/* trans */

#include "main.h"

int have_tests;
pred_set *ps_epos;
pred_set *ps_eneg;
pred_set *ps_theta;
pred_set *ps_bg;
pred_set *ps_tpos;
pred_set *ps_tneg;
pred_set *ps_invent;


void
ps_init()
{
	ps_epos = ps_create();
	ps_eneg = ps_create();
	ps_tpos = ps_create();
	ps_tneg = ps_create();
	ps_bg = ps_create();
	ps_theta = ps_create();
	ps_invent = ps_create();
}

/* the tt object */

lst tt_table;
lst tt_map;

void
create_tt (int num_types)
{
  int j;

  tt_table = lst_new(numentry+2);
  lst_fill(tt_table,(numentry+2),-1);
  tt_map = lst_new(num_types);
  for (j=0;j<num_types;j++) lst_append(tt_map,j);
}

void
add_tt (int ot, int val)
{
  int mapt,unmapt,mapot,j;


  /*printf("addtt ot %d val %d tablesize %d mapsize %d\n",ot,val,lst_size(tt_table),lst_size(tt_map));*/
  unmapt = lst_look(tt_table,val);
  if (unmapt == -1) {
    lst_insert(tt_table,ot,val);
  } else {
    mapt = lst_look(tt_map,unmapt);
    mapot = lst_look(tt_map,ot);
    if (mapt != mapot) {
      for (j=0;j<lst_size(tt_map);j++) {    /* merge */
	if (lst_look(tt_map,j) == mapt) lst_insert(tt_map,mapot,j);
      }
    }
  }
}

int
get_tt (int ot)
{
  return (lst_look(tt_map,ot));
}

void
free_tt ()
{
  lst_free(tt_map);
  lst_free(tt_table);
}


int
type_spreed(lst tl, int re_num)
{
  int j,size,re,e;

  re = re_num;
  size = lst_size(tl);
  for (j=0;j<size;j++) {
    e = lst_look(tl,j);
    switch (e) {
    case REAL_TYPE : lst_insert(tl,REAL_TYPE,j); break;
    case INT_TYPE : lst_insert(tl,INT_TYPE,j); break;
    case SS_TYPE : lst_insert(tl,re,j); re++; break;
    default : error("type_spreed"); break;
    }
  }

  return re;
}

void
add_each_type(lst tl, lst pds)
{
  int i, j, ot, arity;
  lst dl;

  arity = lst_size(tl);
  /* printf("* arity %d size %d tl ",arity,lst_size(pds));
lst_show(tl); printf("\n");*/
  for (i=0;i<lst_size(pds);i++) {
    dl = lst_look(pds,i);
    for (j=0;j<arity;j++) {
      ot = lst_look(tl,j);
      if (ot >= SS_TYPE) {
	add_tt(ot-SS_TYPE,lst_look(dl,j));
      }
    }
  }
}

void
reassign_type(lst tl)
{
  int i, ot;

  for (i=0;i<lst_size(tl);i++) {
    ot = lst_look(tl,i);
    if (ot >= SS_TYPE) {
      lst_insert(tl,get_tt(ot-SS_TYPE)+SS_TYPE,i);
    }
  }
}


/* Learning the type infomation */
void
learn_type()
{
  int re_num, j;

if(DB(dbstage)) printf("=== Type info - reassign\n");
  /* reassign types : pos, neg, bg */
  re_num = SS_TYPE;
  if (ps_epos->num == 1) {
    re_num = type_spreed(ps_epos->preds[0].type,SS_TYPE);
    if (ps_eneg->num == 1) {
      lst_copy(ps_epos->preds[0].type,ps_eneg->preds[0].type);
    } 
  } else {
    if (ps_eneg->num == 1) {
      re_num = type_spreed(ps_eneg->preds[0].type,SS_TYPE);
    } else {
      error ("learn_type");
    }
  }
  for (j=0;j<ps_bg->num;j++) {
    re_num = type_spreed(ps_bg->preds[j].type,re_num);    
  }
if(DB(dbstage)) printf("=== Type info - parse\n");

  /* parse positive example, negative examples, and bg info mergeing types */
  create_tt(re_num-SS_TYPE);
  if (ps_epos->num == 1) {
    add_each_type(ps_epos->preds[0].type,ps_epos->preds[0].preds);
  }
  if (ps_eneg->num == 1) {
    add_each_type(ps_eneg->preds[0].type,ps_eneg->preds[0].preds);
  }
  for (j=0;j<ps_bg->num;j++) {
    add_each_type(ps_bg->preds[j].type,ps_bg->preds[j].preds);
  }
if(DB(dbstage)) printf("=== Type info - reassign 2\n");

  /* reassign types */
  if (ps_epos->num == 1) {
    reassign_type(ps_epos->preds[0].type);
  }
  if (ps_eneg->num == 1) {
    reassign_type(ps_eneg->preds[0].type);
  }
  for (j=0;j<ps_bg->num;j++) {
    reassign_type(ps_bg->preds[j].type);
  }
  free_tt();

}

void
fix_pos()
{
  if (ps_epos->num == 0) {
    if (ps_eneg->num == 1) {
       ps_epos->preds[0].name = ps_eneg->preds[0].name;
       ps_epos->preds[0].arity = ps_eneg->preds[0].arity;
       ps_epos->preds[0].type =  ps_eneg->preds[0].type;
       ps_epos->preds[0].preds = lst_new(0);
       ps_epos->preds[0].number = lst_new(0);
       ps_epos->num = 1;
    } else {
      error("no positive or negative examples??????");
    }
  } 
}


void
add_same(lst el_list,int kt,lst preds,lst type)
{
  int k, j;
  lst p;

  for (k=0;k<lst_size(preds);k++) {
    p = lst_look(preds,k);
    for (j=0;j<lst_size(type);j++) {
      if (lst_look(type,j) == kt) {
	lst_append(el_list,(lst_look(p,j)));
      }
    }
  }
}

/* generates the set of predicate used for theta coverage estimation */
void
gen_theta()
{
  int arity, name, ltype, ppreds, nnum, npreds, pnum;
  int j, k, r, el, kt;
  lst d, lt;
  lst el_lists, el_list;

 
  arity = ps_epos->preds[0].arity;
  name = ps_epos->preds[0].name;
  ltype = ps_epos->preds[0].type;
  ppreds= ps_epos->preds[0].preds;
  pnum = lst_size(ppreds);
  npreds = -1; /* keep the complier quiet */
  if (ps_eneg->num == 1) {
    npreds =  ps_eneg->preds[0].preds;
    nnum = lst_size(npreds);
  } else {
    nnum = 0;
  }

  /* create a list of elements for each term */
  el_lists = lst_new(arity);
  for (k=0;k<arity;k++) {
    el_list = lst_new(arity*(pnum + nnum)*2);
    lst_append(el_lists,el_list);
    kt = lst_look(ltype,k);
    if (pnum != 0) add_same(el_list,kt,ppreds,ltype);
    if (nnum != 0) add_same(el_list,kt,npreds,ltype);
    for (j=0;j<ps_bg->num;j++) {
      add_same(el_list,kt,ps_bg->preds[j].preds,ps_bg->preds[j].type);
    }
  }

  d = lst_new(arity);
  lt = lst_new(arity);
  lst_copy(ltype,lt);
  /*lst_show(lst_look(el_lists,0));*/
  for (j = 0; j < THETASIZE;j++) {
    lst_clear(d);
    for (k = 0; k < arity; k++) {
      el_list = lst_look(el_lists,k);
      r = my_random(lst_size(el_list));
      el = lst_look(el_list,r);
      lst_append(d,el);
      /*printf("r %d el %d ",r,el);*/
    }
    /*printf("\n");*/
    ps_add(ps_theta,name,arity,lt,d);
  }
  lst_free(d);
  lst_free(lt);

  for (k=0;k<arity;k++) {
    lst_free(lst_look(el_lists,k));
  }
  lst_free(el_lists);

}

pred_set
*ps_create()
{
	pred_set *ps;
	ps = (pred_set *) memory (sizeof(pred_set),"creating pred_set");
	ps->num = 0;
	return ps;
}

int
 ps_count (pred_set *ps)
{
  if (ps->num == 1) return (lst_size(ps->preds[0].preds));
  if (ps->num == 0) return 0;
  error("ps_count");
  return -1;
}

void
ps_add(pred_set *ps, int name, int arity, lst tp, lst d)
{
  int i, index, number;
  /*  if (DB(dbtrans))
    printf("ps_add n %d, a %d tl %d dl %d lit_used %d\n",name,arity,tp,d,lst_use);*/
  i = 0;
  while (i < ps->num) {
    if ((name == ps->preds[i].name) && (arity == ps->preds[i].arity)) {
      index = lstlst_find(d,ps->preds[i].preds);
      if (index == -1) {
	lst_append(ps->preds[i].preds, lst_replicate(d));
	lst_append(ps->preds[i].number, 1);
	return;
      } else {
	number = lst_look(ps->preds[i].number,index);
	lst_insert(ps->preds[i].number,number+1,index);
	return;
      }
    }
    i++;
  }
  if (ps->num == MAXPREDS) error("max preds");
  i = ps->num;
  ps->preds[i].name = name;
  ps->preds[i].arity = arity;
  ps->preds[i].type = lst_replicate(tp);
  ps->preds[i].preds = lst_new(PRED_START);
  ps->preds[i].number = lst_new(PRED_START);
  lst_append(ps->preds[i].preds,lst_replicate(d));
  lst_append(ps->preds[i].number,1);
  ps->num++;
}


typedef struct iocombin_struct {
	int num_in;
	int in[4];
	int num_out;
	int out[4];
} iocombin;

iocombin p0[] = {{0,{-1},0,{-1}}};
int p0s = 1;


iocombin p1[] = {{1,{0},0,{-1}},
                 {0,{-1},1,{0}}};
int p1s = 2;
int p1snoconstant  = 1;

iocombin p2[] = {{2,{0,1}, 0,{-1}},
		   {2,{1,0}, 0,{-1}},
		   {1,{0},   1,{1}},
		   {1,{1},   1,{0}}};
int p2s = 4;
iocombin p3[] = {{3,{0,1,2}, 0,{-1}},
		   {3,{0,2,1}, 0,{-1}},
		   {3,{1,0,2}, 0,{-1}},
		   {3,{1,2,0}, 0,{-1}},
		   {3,{2,0,1}, 0,{-1}},
		   {3,{2,1,0}, 0,{-1}},
		   {2,{0,1},   1,{2}},
		   {2,{1,0},   1,{2}},
		   {2,{1,2},   1,{0}},
		   {2,{2,1},   1,{0}},
		   {2,{0,2},   1,{1}},
		   {2,{2,0},   1,{1}},
		   {1,{0},     2,{1,2}},
		   {1,{1},     2,{0,2}},
		   {1,{2},     2,{0,1}}};
int p3s = 15;
iocombin p4[] = {{4,{0,1,2,3},0,{-1}},
		 {4,{0,1,3,2},0,{-1}},
		 {4,{0,2,1,3},0,{-1}},
		 {4,{0,2,3,1},0,{-1}},
		 {4,{0,3,1,2},0,{-1}},
		 {4,{0,3,2,1},0,{-1}},
		 {4,{1,0,2,3},0,{-1}},
		 {4,{1,0,3,2},0,{-1}},
		 {4,{1,2,0,3},0,{-1}},
		 {4,{1,2,3,0},0,{-1}},
		 {4,{1,3,0,2},0,{-1}},
		 {4,{1,3,0,2},0,{-1}},
		 {4,{2,0,1,3},0,{-1}},
		 {4,{2,0,3,1},0,{-1}},
		 {4,{2,1,0,3},0,{-1}},
		 {4,{2,1,3,0},0,{-1}},
		 {4,{2,3,0,1},0,{-1}},
		 {4,{2,3,1,0},0,{-1}},
		 {4,{3,0,1,2},0,{-1}},
		 {4,{3,0,2,1},0,{-1}},
		 {4,{3,1,0,2},0,{-1}},
		 {4,{3,1,2,0},0,{-1}},
		 {4,{3,2,0,1},0,{-1}},
		 {4,{3,2,1,0},0,{-1}},
		 {3,{0,1,2},1,{3}},
		 {3,{0,1,3},1,{2}},
		 {3,{0,2,1},1,{3}},
		 {3,{0,2,3},1,{1}},
		 {3,{0,3,1},1,{2}},
		 {3,{0,3,2},1,{1}},
		 {3,{1,0,2},1,{3}},
		 {3,{1,0,3},1,{2}},
		 {3,{1,2,0},1,{3}},
		 {3,{1,2,3},1,{0}},
		 {3,{1,3,0},1,{2}},
		 {3,{1,3,0},1,{2}},
		 {3,{2,0,1},1,{3}},
		 {3,{2,0,3},1,{1}},
		 {3,{2,1,0},1,{3}},
		 {3,{2,1,3},1,{0}},
		 {3,{2,3,0},1,{1}},
		 {3,{2,3,1},1,{0}},
		 {3,{3,0,1},1,{2}},
		 {3,{3,0,2},1,{1}},
		 {3,{3,1,0},1,{2}},
		 {3,{3,1,2},1,{0}},
		 {3,{3,2,0},1,{1}},
		 {3,{3,2,1},1,{0}},
		 {2,{0,1},2,{2,3}},
		 {2,{0,2},2,{1,3}},
		 {2,{0,3},2,{1,2}},
		 {2,{1,0},2,{2,3}},
		 {2,{1,2},2,{0,3}},
		 {2,{1,3},2,{0,2}},
		 {2,{2,0},2,{1,3}},
		 {2,{2,1},2,{0,3}},
		 {2,{2,3},2,{0,1}},
		 {2,{3,0},2,{1,2}},
		 {2,{3,1},2,{0,2}},
		 {2,{3,2},2,{0,1}},
		 {1,{0},3,{1,2,3}},
		 {1,{1},3,{0,2,3}},
		 {1,{2},3,{0,1,3}},
		 {1,{3},3,{0,1,2}}};
int p4s = 64;



typedef struct ioclst_struct {
  iocombin (*ptr)[];
  int size;
} ioclstt;

/*ioclstt ioclst[4]; = {{p0,p0s},{p1,p1s},{p2,p2s},{p3,p3s}}; */
ioclstt ioclst[5];

void
trans(info *the_info)
{
  int glit_size, glit_num;
  glit (*gen_lit)[];
  pred_set *ps;
  map *m;
  int i, j, k, l, w, q, okay, startcount;
  int arity, size;
  lst preds, type;
  lst in_t, out_t, in_r, out_r;
  iocombin *ptr;
  int in[MAXARITY], out[MAXARITY];
  float bits;
  
  
  
  if (DB(dbstage)) printf("==Trans\n");
  ioclst[0].ptr  = (iocombin (*)[]) p0;
  ioclst[0].size = p0s;
  ioclst[1].ptr  = (iocombin (*)[])p1;
  if (noconstant) {
    ioclst[1].size = p1snoconstant;
  } else {
    ioclst[1].size = p1s;
  }
  ioclst[2].ptr  = (iocombin (*)[])p2;
  ioclst[2].size = p2s;
  ioclst[3].ptr  = (iocombin (*)[])p3;
  ioclst[3].size = p3s;
  ioclst[4].ptr  = (iocombin (*)[])p4;
  ioclst[4].size = p4s;
  
  /* calculate the glit table size */
  if (recursive) {
    startcount = 0; 
  } else { 
    startcount = 1;
  }
  glit_size = 10;
  for (i=startcount;i<2;i++) {                   /* for each pred in E+ and BG */
    if (i == 0) {
      ps = ps_epos;
    } else {
      ps = ps_bg;
    } 
    
    for (j=0;j<ps->num;j++) {
      arity = ps->preds[j].arity;
      switch (arity) {
      case 0 : glit_size += p0s; break;
      case 1 : 
	if (noconstant) {
	  glit_size += p1snoconstant;
	} else {
	  glit_size += p1s; 
	}
	break;
      case 2 : glit_size += p2s; break;
      case 3 : glit_size += p3s; break;
      case 4 : glit_size += p4s; break;
      }
    }
  }
  
  /* create the table */
  glit_num = 0;
  gen_lit = (glit (*)[]) memory (sizeof(glit)*glit_size, "glit");

  for (i=startcount;i<2;i++) {                   /* for each pred in E+ and BG */
    if (i == 0) {
      ps = ps_epos;
    } else {
      ps = ps_bg;
    } 
 
    for (j=0;j<ps->num;j++) {
      arity = ps->preds[j].arity;
      /*      if (arity > 4) error ("arity to big"); */
      if (arity <= 4) {
      type = ps->preds[j].type;
      preds = ps->preds[j].preds;/* for each io combination */
      size = lst_size(preds);
      for (k=0;k<ioclst[arity].size;k++) {
	ptr = &(*ioclst[arity].ptr)[k];
	m = map_create(size, ptr->num_in, ptr->num_out);
	l = 0;
	okay = TRUE;
	while (l < size && okay) { /* for each example */
	  for (w=0;w<ptr->num_in;w++)
	    in[w] = lst_look(lst_look(preds,l), ptr->in[w]);
	  for (w=0;w<ptr->num_out;w++)
	    out[w] = lst_look(lst_look(preds,l), ptr->out[w]);
	  if (!map_add_sort(m,in,out,l)) {
	    okay = FALSE;
	    map_free(m);
	  }
	  l++;
	}
	if (okay) {
	  in_t = lst_new(ptr->num_in);
	  for (w=0;w<ptr->num_in;w++)
	    lst_append(in_t,lst_look(type, ptr->in[w]));
	  out_t = lst_new(ptr->num_out);
	  for (w=0;w<ptr->num_out;w++)
	    lst_append(out_t,lst_look(type, ptr->out[w]));
	  for (q=0;q<glit_num && okay;q++) {
	    /* okay is false if it is the same as one
	       that is already their */
	    okay = ((*gen_lit)[q].num_in != ptr->num_in) ||
	      ((*gen_lit)[q].num_out != ptr->num_out) ||
		(!lst_cmp(in_t,(*gen_lit)[q].type_in)) ||
		  (!lst_cmp(out_t,(*gen_lit)[q].type_out)) ||
		    (!map_cmp(m,(*gen_lit)[q].fun));
	  }
	  /* calculate bits */
	  bits = (3.0 + (2.0 * arity)); /* divide 3.0 */ 
	  if (okay) {  /* add the new one */
	    if (glit_num == glit_size) error("glit is to big");
	    (*gen_lit)[glit_num].num_in = ptr->num_in;
	    (*gen_lit)[glit_num].num_out = ptr->num_out;
	    (*gen_lit)[glit_num].type_in = in_t;
	    (*gen_lit)[glit_num].type_out = out_t;
	    (*gen_lit)[glit_num].fun = m;
	    (*gen_lit)[glit_num].symtric = FALSE;
	    (*gen_lit)[glit_num].byjection = FALSE;
	    (*gen_lit)[glit_num].bits = bits;
	    (*gen_lit)[glit_num].raw_pred = (i==0) ? (-1) : j;
	    in_r = lst_new(ptr->num_in);
	    for (w=0;w<ptr->num_in;w++)
	      lst_append(in_r, ptr->in[w]);
	    out_r = lst_new(ptr->num_out);
	    for (w=0;w<ptr->num_out;w++)
	      lst_append(out_r, ptr->out[w]);
	    (*gen_lit)[glit_num].raw_in_bind = in_r;
	    (*gen_lit)[glit_num].raw_out_bind = out_r;
	    if (DB(dbtrans)) {
	      printf("new pred %d from %d in ",
		     glit_num,
		     (*gen_lit)[glit_num].raw_pred);
	      lst_show(in_r); printf(" out ");
	      lst_show(out_r); printf("\n");
	    }
	    /* add byjection stuff */
	    glit_num++;
	  } else { /* either replace old one or remove totally */
	    map_free(m);
	    lst_free(in_t);
	    lst_free(out_t);
	    if (bits < (*gen_lit)[q].bits) {
	      (*gen_lit)[q].bits = bits;
	      (*gen_lit)[q].raw_pred = (i==0) ? (-1) : j;
	      in_r = lst_new(ptr->num_in);
	      for (w=0;w<ptr->num_in;w++)
		lst_append(in_r, ptr->in[w]);
	      out_r = lst_new(ptr->num_out);
	      for (w=0;w<ptr->num_out;w++)
		lst_append(out_r, ptr->out[w]);
	      (*gen_lit)[q].raw_in_bind = in_r;
	      (*gen_lit)[q].raw_out_bind = out_r;
	    }
	  }
	}
      }
      }
    }
  }
  
  /* learn type info */
  
  /* add to info */
  
  info_add_genlit (the_info, glit_size, glit_num, gen_lit);
}

void
show_pred_set(pred_set *ps)
{
  int i,j,k, r;
  pred *a;
  printf("ps num %d\n",ps->num);
  for (i=0;i<ps->num;i++) {
    a = &(ps->preds[i]);
    printf("name %d, arity %d, type ",a->name,a->arity);
    for (j=0;j<a->arity;j++) printf("%d ",lst_look(a->type,j));
    printf("\n");
    for (j=0;j<lst_size(a->preds);j++) {
      printf("(%1d) ",lst_look(a->number,j));
      for (k=0;k<a->arity;k++) {
	r = lst_look((lst_look(a->preds,j)),k);
	switch (lst_look(a->type,k)) {
	case 0 : printf("%d ",r); break;
	case 1 : printf("%e ",(float) r); break;
	default : printf("%s ",(*symtable)[lst_look(symtmap,r)].lexptr); break;
	}
      }
      printf("\n");
    }
  }
}

void
show_an_example (lst data, lst type) 
{
  int k;
  int r;

  printf("(");
  for (k=0;k<lst_size(type);k++) {
    r = lst_look(data,k);
    if (r == -1) {
      printf ("X");
    } else {
      switch (lst_look(type,k)) {
      case INT_TYPE : printf("%d",r); break;
      case REAL_TYPE : printf("%e",(float) r); break;
      default : printf("%s",(*symtable)[lst_look(symtmap,r)].lexptr); break;
      }
    }
    if (k != (lst_size(type)-1)) printf (",");
  }
  printf(")");

}

void
show_gen_lit(info *i)
{
  int num, j;
  glit *g;
  
  num = i->num_gen_lit;
  
  printf("num_gen_lit %d\n",num);
  for (j=0;j<num;j++) {
    g = &((*i->gen_lit)[j]);
    printf("glit %d #i %d #o %d ti ",j,g->num_in,g->num_out);
    lst_show(g->type_in);
    printf(" to "); lst_show(g->type_out);
    printf(" b %e",g->bits);
    printf(" rp %d\n",g->raw_pred);
    map_show(g->fun);
  }
  
}

